<script setup lang="ts">
import axios from "axios";
import { ref, onMounted } from "vue";
import router from "../router/index";

let fileSrc = ref("");
let thumbSrc = ref("");
let showEmbed = ref(true);
let showThumb = ref(true);
let error = ref();
let kitab = ref();

var id = router.currentRoute.value.params.id;
const backendURL = import.meta.env.VITE_BACKEND_URL;

onMounted(async () => {
    const response = await axios({
      method: "get",
      url: `${backendURL}/kitab/` + id
    });
    kitab.value = response.data;
    fileSrc.value = kitab.value.filePreviewLink;
    thumbSrc.value = kitab.value.thumbnailPreviewLink;
    document.getElementById("input-title")!.setAttribute('value', kitab.value.title);
    document.getElementById("input-language")!.setAttribute('value', kitab.value.language);
    document.getElementById("input-author")!.setAttribute('value', kitab.value.author);
    document.getElementById("input-locationWritten")!.setAttribute('value', kitab.value.locationWritten);
    document.getElementById("input-type")!.setAttribute('value', kitab.value.type);
    document.getElementById("input-media")!.setAttribute('value', kitab.value.media);
    document.getElementById("input-ink")!.setAttribute('value', kitab.value.ink);
    document.getElementById("input-illumination")!.setAttribute('value', kitab.value.illumination);
    document.getElementById("input-desc")!.setAttribute('value', kitab.value.desc);
})

const sendInfoForm = async () => {

  const formData = new FormData(
    <HTMLFormElement>document.getElementById("info-form-corpus")
  );

  try {
    await axios({
      method: "put",
      url: `${backendURL}/kitab/update/` + id ,
      data: formData,
      headers: { "Content-Type": "multipart/form-data" },
    });
    document.getElementById("input-desc")!.setAttribute('value', '');
    router.push("/corpus");
  } catch (err) {
    error.value = err;
    setTimeout(() => {
      error.value = null;
    }, 3000);
  }
};
</script>

<template>
  <div class="animate__animated animate__fadeIn">
    <div class="flex flex-col md:grid md:grid-cols-2 gap-2">
      <div class="p-6">
        <div id="error-verify" class="text-red-500 ml-8">{{ error }}</div>
        <form id="file-form-corpus" class="h-full md:pl-5 pr-6">
          <div class="flex justify-between ...">
            <p class="label-regis-login ml-4 mb-2">
              File Korpus
            </p>
          </div>

          <label class="w-full mb-6 label-box-file-corpus">

            <embed
              id="embed-file-corpus"
              v-if="showEmbed"
              type="application/pdf"
              :src="fileSrc"
              width="100%"
              height="100%"
            />
          </label>
          <div class="flex justify-between ...">
            <p class="label-regis-login ml-4 mb-2">Halaman Sampul</p>
          </div>
          <label class="w-full mb-6 label-box-thumb-corpus">

            <img
              v-if="showThumb"
              class="input-box-file-corpus"
              style="object-fit: contain"
              :src="thumbSrc"
              alt="Thumbnail"
            />
          </label>
        </form>
      </div>
      <div id="right-side" class="grid grid-cols-2 content-center md:px-6 py-5">
        <form
          id="info-form-corpus"
          @submit.prevent="sendInfoForm"
          class="col-span-2 px-6"
        >
          <div class="field px-6">
            <div class="col-auto">
              <p class="label-regis-login">
                Judul<span style="color: red"> *</span>
              </p>
              <input
                id="input-title"
                type="text"
                name="title"
                placeholder="Transliterasi Pegon Bertahap"
                required
                class="input-box-form-corpus"
              />
            </div>

            <div class="col-span-1">
              <p class="label-regis-login">
                Bahasa<span style="color: red"> *</span>
              </p>
              <select
                id="input-language"
                name="language"
                class="input-box-form-corpus"
              >
                <option value="jawa">Jawa</option>
                <option value="sunda">Sunda</option>
                <option value="madura">Madura</option>
                <option value="indonesia">Indonesia</option>
              </select>
            </div>

            <div>
              <p class="label-regis-login">Penulis</p>
              <input
                id="input-author"
                type="text"
                name="author"
                placeholder="Asep Sutarma"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Tanggal Ditulis<span style="color: red"> *</span></p>
              <input
                id="input-timeWritten"
                name="timeWritten"
                type="date"
                class="input-box-form-corpus"
                value="1970-01-01"
              />
            </div>
            <div>
              <p class="label-regis-login">Tempat Ditulis</p>
              <input
                id="input-locationWritten"
                name="locationWritten"
                type="text"
                placeholder="Magelang"
                class="input-box-form-corpus"
              />
            </div>

            <div class="col-span-1">
              <p class="label-regis-login">Jenis</p>
              <input
                id="input-type"
                name="type"
                type="text"
                placeholder="kitab kuning"
                class="input-box-form-corpus"
              />
            </div>
            <div>
              <p class="label-regis-login">Media</p>
              <input
                id="input-media"
                name="media"
                type="text"
                placeholder="daluang"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Tinta</p>
              <input
                id="input-ink"
                name="ink"
                type="text"
                placeholder="masi"
                class="input-box-form-corpus"
              />
            </div>
            <div>
              <p class="label-regis-login">Iluminasi</p>
              <input
                id="input-illumination"
                name="illumination"
                type="text"
                placeholder="bingkai"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Deskripsi<span style="color: red"> *</span></p>
              <textarea
                id="input-desc"
                name="desc"
                type="text"
                placeholder="Sebuah korpus peninggalan pada zaman dahulu"
                class="input-box-textarea-corpus"
              />
            </div>

            <button class="btn-regis-login" type="submit">Simpan</button>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<style>
.input-box-form-corpus {
  color: white;
  background: #2d2e2d;
  border-radius: 10px;
  display: flex;
  min-width: 100%;
  min-height: 40px;
  color-scheme: dark;
  @apply mb-6 pl-3 pr-3;
}

.input-box-textarea-corpus {
  color: white;
  background: #2d2e2d;
  border-radius: 10px;
  display: flex;
  min-width: 100%;
  min-height: 40px;
  @apply mb-6 pl-3 pr-3 pt-2;
}

.label-box-file-corpus {
  background: #2d2e2d;
  border-radius: 15px;
  height: 59%;
}

.label-box-thumb-corpus {
  background: #2d2e2d;
  border-radius: 15px;
  height: 30%;
}

.input-box-file-corpus {
  background: #2d2e2d, transparent;
  border-radius: 10px;
  width: 100%;
  border: none;
}

.button-box-file-corpus {
  margin: 0;
  position: absolute;
  top: 50%;
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
}

select {
  border-right: 16px solid transparent
}
</style>